(module js2post
   (import js-nodes	
	   js-parser
	   js-out
	   config
	   verbose
	   vardecl
	   cpstrans
	   trampoline
	   optim-admin
	   finalize)
   (export (js2post-compile-file in-p out-p varl)))

(define (js2post-compile-file in-p out-p varl)
   (let* ((tree (parse in-p
		      (lambda ()
			 (error "parse"
				"An error occured in parsing process"
				#f)))))
      (verbose "\n**Original Parsing Tree**:\n==================================")
      (verbose tree)

      (set! tree (var-decl-normal-form! tree))
      (verbose "\n**Normal Form Tree**:\n==================================")
      (verbose tree)
      
      ;(js-out tree out-p :compress? #f)
      (cps-transform! tree)
      (verbose "\n**CPS-transformed Tree**:\n==================================")
      (verbose tree)

      (optim-administrative! tree)
      (verbose "\n**Optimized (administrative steps) Tree**:\n==================================")
      (verbose tree)
      
      (trampoline! tree)
      (verbose "\n**Trampoline-enabled Tree**:\n==================================")
      (verbose tree)

      (finalize! tree)
      ;(verbose "\n**Trampoline-enabled Tree**:\n==================================")
      ;(verbose tree)

      ;;Write the result output port
      (js-out tree out-p :compress? #t)))