(module optim-admin
   (import js-nodes
	   js-parser
	   js-out
	   js-nodes-extra
	   config
	   verbose
	   walk)
   (export (optim-administrative! tree)))

(define (optim-administrative! tree)
   (optim-admin! tree #f))


(define-nmethod (Node.optim-admin!)
   (default-walk! this)
   this)

(define (optimizable? tree)
   (if (Call-Cps? tree)
       (with-access::Call-Cps tree (fun args)
	  (if (Cps-Code? fun)
	      (with-access::Cps-Code fun (params body)
		 (if (and (= 1 (length params))
			  (Ref? (car params)))
		     (with-access::Ref (car params) (id)
			(let ((kont id))
			   (with-access::Block body (stmts)
			      (if (= 1 (length stmts))
				  (if (Call-Cont? (car stmts))
				      (with-access::Call-Cont (car stmts) (fun args)
					 (if (Ref? fun)
					     (with-access::Ref fun (id)
						(if (equal? kont id)
						    args
						    #f))
					     #f))
				      #f)
				  #f))))
		     #f))
	      #f))
       #f))

(define-nmethod (Call-Cps.optim-admin!)
   (default-walk! this)
   (let ((res (optimizable? this)))
      (if (not res)
	  this
	  (with-access::Call-Cps this (fun args)
	     (if (= 1 (length args))
		 (make-Call-Cont (car args) res)
		 (error "optim-admin!"
			"Wonder why this would happen?"
			#f))))))



