
//parameters
var untrusted_origin="http://nose.inria.fr";
var untrusted_iframe=false;
var untrusted_iframe_id='iframe';


//Initailize the list for storing continuations and callback functions
var set_cont;
var get_cont;
var set_callback;
var get_callback;

(function(){
    var cont_list = new Object();
    var callback_list = new Object();

    //Set continuations
    set_cont = function(msg_id,cont){
	cont_list[msg_id.toString()] = cont;
    }
    
    //Get continuations
    get_cont = function(msg_id){
	return cont_list[msg_id.toString()];
    }
    
    //Set callbacks
    set_callback = function(fhandle,callback){
	cont_list[fhandle.__id.toString()] = callback;
    }
    
    //Get continuations
    get_callback = function(fhandle){
	return cont_list[fhandle.__id.toString()];
    }
})();

function message_handler(e){
  var recv = JSON.parse(e.data);
  var val;
  switch(recv.msg_type){
      //execute continuation	
  case 'EXE_CONT':
      var cont = get_cont(recv.msg_id);
      if (cont!=null){
	  set_cont(recv.msg_id,null);
	  if (cont.val!=undefined){
	      val = cont.val;
	  }else{
	      val = recv.return_val;
	  }
	  if (tramp_on)
	      execute_as_tramp(cont,val);
	  else
	      cont(recv.val);
      }
      else{
	  throw "Null continuation";
      }
      break;
      //execute callback function
  case 'CALLBACK':
      var callback = get_callback(recv._function);
      if (callback!=null){
	  if (tramp_on)
	      callback_as_tramp(callback,recv.arguments);
	  else
	      callback.apply(null,recv.arguments);
      }
      else{
	  throw "Null callback";
      }
      break;
  }
}

//init the message handler
(function(){
    window.addEventListener("message", message_handler, false);
})();

// function val_recon(val){
//     return val;
// }

// function args_recon(args){
//     return args;
// }

function postMsg(message){
    if (!untrusted_iframe)
	untrusted_iframe = document.getElementById(untrusted_iframe_id).contentWindow;
    json_message =  JSON.stringify(message);
    verbose("O=>I Request"/*,untrusted_origin */, " : ", json_message);
    untrusted_iframe.postMessage(json_message,untrusted_origin);
}

function GET_GLOBAL_REF(global_name,cont){
    
    //send message
    var m_id = msg_id_gen();
    var msg =  {msg_id : m_id, msg_type : 'GET_GLOBAL_REF', global_name : global_name};
    postMsg(msg);
    
    //register continuation
    set_cont(m_id,cont);
    return;
}


function GET_PROPERTY(obj,prop,cont){
    //send message
    var m_id = msg_id_gen();
    var msg =  {msg_id : m_id, msg_type: 'GET_PROPERTY', object : obj, property_name : prop};
    postMsg(msg);
    
    //register continuation
    set_cont(m_id,cont);
    return;
}

function OBJ_PROP_ASSIGN(obj,prop,val,cont){
    //send message
    var m_id = msg_id_gen();
    var send_val;
    if (typeof val == 'function'){
	send_val = new FHandle();
	set_callback(send_val,val);
    }else{
	send_val=val;
    }
    var msg =  {msg_id : m_id, msg_type: 'OBJ_PROP_ASSIGN', object : obj, property_name : prop, value: send_val};
    postMsg(msg);
    
    //NEED TO REFINE THIS
    cont.val=val;
    
    //register continuationn
    set_cont(m_id,cont);
    return;
}

function construct_args(offset, __arguments){
    var args = new Array();
    for (var i= 0 + offset; i<__arguments.length; i++){
	if (typeof __arguments[i] == 'function'){
	    args[i - offset] = new FHandle();
	    set_callback(args[i - offset],__arguments[i]);
	}
	else{
	    args[i - offset] = __arguments[i];
	}
    }
    return args;
}

function construct_args_untouch(offset, __arguments){
    var args = new Array();
    for (var i= 0 + offset; i<__arguments.length; i++){
	args[i - offset] = __arguments[i];
    }
    return args;
}

function CALL_FUNCTION(fun,cont,args){
   //send message
    var m_id = msg_id_gen();

    // var offset =2;
    // var args = construct_args(offset,arguments);
    
    var msg =  {msg_id : mid, msg_type : 'CALL_FUNCTION', _function : fun, arguments : args};
    postMsg(msg);
    
    //register continuation
    set_cont(mid,cont);
    return;
}

function CALL_METHOD(obj,method,cont,args){
   //send message
    var m_id = msg_id_gen();

    //var offset = 3;
    //var args = construct_args(offset,arguments);
    
    var msg =  {msg_id : m_id, msg_type: 'CALL_METHOD', object : obj, method_name: method, arguments : args};
    postMsg(msg);

    //register continuation
    set_cont(m_id,cont);
    return;
}

function NEW_OBJECT(fun,cont,args){
   //send message
    var m_id = msg_id_gen();
   
    // var offset =2;
    // var args = construct_args(offset,arguments);
    
    var msg =  {msg_id : m_id, msg_type : 'NEW_OBJECT', _function : fun, arguments : args};
    postMsg(msg);
    
    //register continuation
    set_cont(m_id,cont);
    return;
}


function __ACCESS(kont,obj,prop){
    if (obj.__is_ohandle)
	return GET_PROPERTY(obj,prop,kont);
    else
	return kont(obj[prop]);
}



function __METHODCALL(kont,object,method){
    var fun,args;
    var offset =3;

    if (object.__is_ohandle){
	args = construct_args(offset,arguments);
	return CALL_METHOD(object,method,kont,args);
    }else{//NEED TO TEST IF THE FUNCTION IS CPS STYLE OR NOT
	fun=object[method];
	args=construct_args_untouch(offset,arguments);
	if(fun.__is_cps){	    
	    args.unshift(kont);
	    return fun.apply(object,args);
	}else
	    return kont(fun.apply(object,args));					    
    }
}

function __FUNCALL(kont,object){
    var fun;
    
    var offset =2;
    var args;
    
    if (object.__is_ohandle){
	args = construct_args(offset,arguments);
	return CALL_FUN(object,kont,args);
    }else{//NEED TO TEST IF THE FUNCTION IS CPS STYLE OR NOT
	fun=object;
	args = construct_args_untouch(offset,arguments);
	if(fun.__is_cps){	    
	    args.unshift(kont);
	    return fun.apply(null,args);
	} else
	    return kont(fun.apply(null,args));					    
    }    
}

function __NEW(kont,fun){
    var offset =2;
    var args = construct_args(offset,arguments);

    var val;

    var new_kont;

    if(fun.__is_ohandle){
	return NEW_OBJECT(fun,kont,args);
    }else{
	if(!fun.__is_cps){
	    if (args.length == 0)
		val = new fun();
	    else{
		var expr = new String;
		expr = "new fun(";
		for (var i = 0; i<args.length - 1; i++)
		    expr = expr + "args[" + i + "],";
		expr  = expr + "args[" + i + "])";
		val = eval(expr);
	    }	
	}else{
	    new_kont=(
		      function(v){
			  return kont(val);
		      });
	    if (args.length == 0)
		return (val = new fun(new_kont));
	    else{
		var expr = new String;
		expr = "new fun(new_kont,";
		for (var i = 0; i<args.length - 1; i++)
		    expr = expr + "args[" + i + "],";
		expr  = expr + "args[" + i + "])";
		return (val = eval(expr));
	    }
	}
	return kont(val);
    }
}

function __GETREF(global_name,cont){
    GET_GLOBAL_REF(global_name,cont);
}

function __ACCSIG(kont,obj,prop,val){
    if (obj.__is_ohandle && obj.hasOwnProperty('__is_ohandle')){
	return OBJ_PROP_ASSIGN(obj,prop,val,kont);
    }else{
	obj[prop]=val;
	return kont(val);
    }
}

function __MAKEFUN(fun){    //CAUTION: need a better way to test if it is supplied with continuations!
    var returnfun = function(){
	//var offset = 0;
	//var args = construct_args(offset,arguments);
	var args = new Array();
	//verbose("Type of first argument is: ", typeof(arguments[0]));
	for (var i=0; i<arguments.length; i++)
	    args[i]=arguments[i];
	if (typeof(args[0]) != 'function'){
	    args.unshift(function(){});
	}
	
	if(tramp_in_flag)
	    return fun.apply(this,args);
	else{
	    var _res_or_tramp;
	    _c_g = 0;
	    tramp_in_flag=true;
	    _res_or_tramp=fun.apply(this,args);
	    while (_res_or_tramp instanceof __Tramp)
		_res_or_tramp = _res_or_tramp.restart();
	    tramp_in_flag=false;
	    return _res_or_tramp;
	}

    };
    returnfun.__is_cps=true;
    return returnfun;
}
