var initialLocation;
var siberia;
var newyork;
var browserSupportFlag =  new Boolean();
var map;
var infowindow;
  
function initialize() {
    siberia = new google.maps.LatLng(60, 105);
    newyork = new google.maps.LatLng(40.69847032728747, -73.9514422416687);
    infowindow = new google.maps.InfoWindow();
    var myOptions = {
	zoom: 6,
	mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    map = new google.maps.Map(iframe.getElementById("map_canvas"), myOptions);
  
    // Try W3C Geolocation method (Preferred)
    if(navigator.geolocation) {
	browserSupportFlag = true;
	navigator.geolocation.getCurrentPosition(function(position) {
		initialLocation = new google.maps.LatLng(position.coords.latitude,position.coords.longitude);
		contentString = "Location found using W3C standard";
		map.setCenter(initialLocation);
		infowindow.setContent(contentString);
		infowindow.setPosition(initialLocation);
		infowindow.open(map);
	    }, function() {
		handleNoGeolocation(browserSupportFlag);
	    });
    } else if (google.gears) {
	// Try Google Gears Geolocation
	browserSupportFlag = true;
	var geo = google.gears.factory.create('beta.geolocation');
	geo.getCurrentPosition(function(position) {
		initialLocation = new google.maps.LatLng(position.latitude,position.longitude);
		contentString = "Location found using Google Gears";
		map.setCenter(initialLocation);
		infowindow.setContent(contentString);
		infowindow.setPosition(initialLocation);
		infowindow.open(map);
	    }, function() {
		handleNoGeolocation(browserSupportFlag);
	    });
    } else {
	// Browser doesn't support Geolocation
	browserSupportFlag = false;
	handleNoGeolocation(browserSupportFlag);
    }
}
 
function handleNoGeolocation(errorFlag) {
  if (errorFlag == true) {
    initialLocation = newyork;
    contentString = "Error: The Geolocation service failed.";
  } else {
    initialLocation = siberia;
    contentString = "Error: Your browser doesn't support geolocation. Are you in Siberia?";
  }
  map.setCenter(initialLocation);
  infowindow.setContent(contentString);
  infowindow.setPosition(initialLocation);
  infowindow.open(map);
}